package envers;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.OneToMany;
import javax.persistence.OrderColumn;

import org.hibernate.envers.Audited;
import org.hibernate.envers.ModificationStore;
import org.hibernate.envers.RelationTargetAuditMode;

@Entity
@Audited
public class AudParent {

    @Id
    @GeneratedValue
    private Long id;
    
    private String name;
    
    @Audited(modStore=ModificationStore.FULL,targetAuditMode=RelationTargetAuditMode.AUDITED)
    @OneToMany(mappedBy="parent",cascade=CascadeType.ALL)
    @OrderColumn(name="index")
    private List<AudChild> children = new ArrayList<AudChild>();
    
    public AudParent(Long id) {
        super();
        this.id = id;
    }

    public AudParent() {
        super();
    }

    public AudParent(String name) {
        super();
        this.name = name;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Long getId() {
        return id;
    }

    public List<AudChild> getChildren() {
        return children;
    }
}
